// Generated with smithy-dart 0.1.1. DO NOT MODIFY.

/// # Amazon DynamoDB
///
/// ## Amazon DynamoDB
///
/// Amazon DynamoDB is a fully managed NoSQL database service that provides fast and predictable performance with seamless scalability. DynamoDB lets you offload the administrative burdens of operating and scaling a distributed database, so that you don't have to worry about hardware provisioning, setup and configuration, replication, software patching, or cluster scaling.
///
/// With DynamoDB, you can create database tables that can store and retrieve any amount of data, and serve any level of request traffic. You can scale up or scale down your tables' throughput capacity without downtime or performance degradation, and use the Amazon Web Services Management Console to monitor resource utilization and performance metrics.
///
/// DynamoDB automatically spreads the data and traffic for your tables over a sufficient number of servers to handle your throughput and storage requirements, while maintaining consistent and fast performance. All of your data is stored on solid state disks (SSDs) and automatically replicated across multiple Availability Zones in an Amazon Web Services Region, providing built-in high availability and data durability.
library smoke_test.dynamo_db;

export 'package:smoke_test/src/sdk/src/dynamo_db/dynamo_db_client.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/archival_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/attribute_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/attribute_definition.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/attribute_value.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/attribute_value_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/auto_scaling_policy_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/auto_scaling_policy_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/auto_scaling_settings_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/auto_scaling_settings_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/auto_scaling_target_tracking_scaling_policy_configuration_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/auto_scaling_target_tracking_scaling_policy_configuration_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_details.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_in_use_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/backup_type_filter.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_execute_statement_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_execute_statement_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_get_item_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_get_item_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_statement_error.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_statement_error_code_enum.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_statement_request.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_statement_response.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_write_item_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/batch_write_item_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/billing_mode.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/billing_mode_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/cancellation_reason.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/capacity.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/comparison_operator.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/condition.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/condition_check.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/conditional_check_failed_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/conditional_operator.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/consumed_capacity.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/continuous_backups_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/continuous_backups_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/continuous_backups_unavailable_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/contributor_insights_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/contributor_insights_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/contributor_insights_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_backup_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_backup_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_global_secondary_index_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_global_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_global_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_replica_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_replication_group_member_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/create_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/csv_options.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_backup_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_backup_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_global_secondary_index_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_item_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_item_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_replica_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_replication_group_member_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_request.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/delete_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_backup_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_backup_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_continuous_backups_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_continuous_backups_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_contributor_insights_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_contributor_insights_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_endpoints_request.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_endpoints_response.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_export_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_export_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_global_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_global_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_global_table_settings_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_global_table_settings_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_import_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_import_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_kinesis_streaming_destination_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_kinesis_streaming_destination_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_limits_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_limits_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_table_replica_auto_scaling_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_table_replica_auto_scaling_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_time_to_live_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/describe_time_to_live_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/destination_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/duplicate_item_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/endpoint.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/execute_statement_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/execute_statement_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/execute_transaction_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/execute_transaction_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/expected_attribute_value.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_conflict_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_format.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_table_to_point_in_time_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/export_table_to_point_in_time_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/failure_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/get.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/get_item_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/get_item_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_secondary_index.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_secondary_index_auto_scaling_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_secondary_index_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_secondary_index_info.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_secondary_index_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_table.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_table_already_exists_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_table_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_table_global_secondary_index_settings_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_table_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/global_table_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/idempotent_parameter_mismatch_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_conflict_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_table_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/import_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/index_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/index_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/input_compression_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/input_format.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/input_format_options.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/internal_server_error.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/invalid_endpoint_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/invalid_export_time_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/invalid_restore_time_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/item_collection_metrics.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/item_collection_size_limit_exceeded_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/item_response.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/key_schema_element.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/key_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/keys_and_attributes.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/kinesis_data_stream_destination.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/kinesis_streaming_destination_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/kinesis_streaming_destination_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/limit_exceeded_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_backups_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_backups_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_contributor_insights_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_contributor_insights_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_exports_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_exports_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_global_tables_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_global_tables_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_imports_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_imports_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_tables_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_tables_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_tags_of_resource_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/list_tags_of_resource_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/local_secondary_index.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/local_secondary_index_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/local_secondary_index_info.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/parameterized_statement.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/point_in_time_recovery_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/point_in_time_recovery_specification.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/point_in_time_recovery_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/point_in_time_recovery_unavailable_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/projection.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/projection_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/provisioned_throughput.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/provisioned_throughput_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/provisioned_throughput_exceeded_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/provisioned_throughput_override.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/put.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/put_item_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/put_item_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/put_request.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/query_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/query_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_already_exists_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_auto_scaling_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_auto_scaling_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_global_secondary_index.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_global_secondary_index_auto_scaling_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_global_secondary_index_auto_scaling_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_global_secondary_index_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_global_secondary_index_settings_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_global_secondary_index_settings_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_settings_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_settings_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replica_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/replication_group_update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/request_limit_exceeded.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/resource_in_use_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/resource_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/restore_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/restore_table_from_backup_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/restore_table_from_backup_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/restore_table_to_point_in_time_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/restore_table_to_point_in_time_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/return_consumed_capacity.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/return_item_collection_metrics.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/return_value.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/return_values_on_condition_check_failure.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/s3_bucket_source.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/s3_sse_algorithm.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/scalar_attribute_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/scan_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/scan_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/select.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/source_table_details.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/source_table_feature_details.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/sse_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/sse_specification.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/sse_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/sse_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/stream_specification.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/stream_view_type.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_already_exists_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_auto_scaling_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_class.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_class_summary.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_creation_parameters.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_in_use_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_not_found_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/table_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/tag.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/tag_resource_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/time_to_live_description.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/time_to_live_specification.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/time_to_live_status.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transact_get_item.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transact_get_items_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transact_get_items_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transact_write_item.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transact_write_items_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transact_write_items_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transaction_canceled_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transaction_conflict_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/transaction_in_progress_exception.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/untag_resource_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_continuous_backups_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_continuous_backups_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_contributor_insights_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_contributor_insights_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_global_secondary_index_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_global_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_global_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_global_table_settings_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_global_table_settings_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_item_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_item_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_replication_group_member_action.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_table_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_table_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_table_replica_auto_scaling_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_table_replica_auto_scaling_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_time_to_live_input.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/update_time_to_live_output.dart';
export 'package:smoke_test/src/sdk/src/dynamo_db/model/write_request.dart';
