// Copyright 2022 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/// Common components and utilities for example apps in amplify dart.
library example_common;

export 'src/components/builder_component.dart';
export 'src/components/button_component.dart';
export 'src/components/center_component.dart';
export 'src/components/component.dart';
export 'src/components/container_component.dart';
export 'src/components/flex_component.dart';
export 'src/components/form_component.dart';
export 'src/components/table_component.dart';
export 'src/components/text_component.dart';
export 'src/components/text_form_field_component.dart';

export 'src/enums.dart';

export 'src/utils/component_edge_insets.dart';
export 'src/utils/render_app.dart';
